/* aamc.c ghh Mon Dec  4 21:38:54 JST 2000 */
/* digital filter for TAMA modecleaner alignment */

#include "aamc.h"

extern unsigned adsum[8];
extern unsigned char adn0, adn1, adgroup, adfast;

void __attribute__ ((interrupt_handler)) int_adi (void)
{
  unsigned char dummy;
  /* clear ADF bit */
  dummy = AD.CSR.BYTE;
  AD.CSR.BYTE = 0x00;		/* stop conversion */

  /* get results */
  if (adgroup == 0)
    {
      if (adn0 < 16)
	{
	  adsum[0] += AD.DRA / 16;
	  adsum[1] += AD.DRB / 16;
	  adsum[2] += AD.DRC / 16;
	  adsum[3] += AD.DRD / 16;
	  ++adn0;
	}
      adgroup = 1;
      if (adfast)
	AD.CSR.BYTE = 0x7f;	/* interrupt, start, scan, fast, ch 4-7 */
      else
	AD.CSR.BYTE = 0x77;	/* interrupt, start, scan, slow, ch 4-7 */
    }
  else
    {
      if (adn1 < 16)
	{
	  adsum[4] += AD.DRA / 16;
	  adsum[5] += AD.DRB / 16;
	  adsum[6] += AD.DRC / 16;
	  adsum[7] += AD.DRD / 16;
	  ++adn1;
	}
      adgroup = 0;
      if (adfast)
	AD.CSR.BYTE = 0x7b;	/* interrupt, start, scan, fast, ch 0-3 */
      else
	AD.CSR.BYTE = 0x73;	/* interrupt, start, scan, slow, ch 0-3 */
    }
}
