#include <stdio.h>

/* This program (intended to run ONCE ONLY on a PC/workstation)
   produces a table of 256 bit-reversed bytes, for use
   in the microcontroller program that addresses the DAC chip */
   
/* Gerhard Heinzel TAMA November 2000 */



unsigned char
bitrev (unsigned char in)
{
  unsigned char out = 0;
  int i;
  for (i = 0; i < 8; i++)
    {
      out <<= 1;		/* shift out to right */
      out |= (in & 0x01);	/* copy LSB */
      in >>= 1;			/* shift in to left */
    }
  return out;
}


int
main (void)
{
  unsigned a;
  printf ("static const unsigned char br[256] = {\n  ");

  for (a = 0; a <= 255; a++)
    printf ("0x%02x%s", bitrev ((unsigned char) a),
	    (a == 255 ? "};\n" : (a % 8 == 7 ? ",\n  " : ", ")));
}
