/* convert.c ghh 7 July 2000*/
/* Data Conversion routines */
/* for  h8300-hms-gcc / 3048F */

#include "aamc.h"

void
utoa5 (char *s, unsigned u)
{
  *(s + 4) = u % 10 + '0';
  u /= 10;
  *(s + 3) = u % 10 + '0';
  u /= 10;
  *(s + 2) = u % 10 + '0';
  u /= 10;
  *(s + 1) = u % 10 + '0';
  u /= 10;
  *(s + 0) = u % 10 + '0';
}

void ltoa11(char*s, long i)
{
  if (i < 0)
    {
      *s = '-';
      i = -i;
    }
  else
    *s = '+';
  *(s + 10) = i % 10 + '0';
  i /= 10;
  *(s + 9) = i % 10 + '0';
  i /= 10;
  *(s + 8) = i % 10 + '0';
  i /= 10;
  *(s + 7) = i % 10 + '0';
  i /= 10;
  *(s + 6) = i % 10 + '0';
  i /= 10;
  *(s + 5) = i % 10 + '0';
  i /= 10;
  *(s + 4) = i % 10 + '0';
  i /= 10;
  *(s + 3) = i % 10 + '0';
  i /= 10;
  *(s + 2) = i % 10 + '0';
  i /= 10;
  *(s + 1) = i % 10 + '0';
}

int
itoa6 (char *s, int i)
{
  if (i < 0)
    {
      *s = '-';
      i = -i;
    }
  else
    *s = '+';
  if (i >= 10000)
    {
      *(s + 5) = i % 10 + '0';
      i /= 10;
      *(s + 4) = i % 10 + '0';
      i /= 10;
      *(s + 3) = i % 10 + '0';
      i /= 10;
      *(s + 2) = i % 10 + '0';
      i /= 10;
      *(s + 1) = i % 10 + '0';
      return 6;
    }
  else if (i >= 1000)
    {
      *(s + 4) = i % 10 + '0';
      i /= 10;
      *(s + 3) = i % 10 + '0';
      i /= 10;
      *(s + 2) = i % 10 + '0';
      i /= 10;
      *(s + 1) = i % 10 + '0';
      return 5;
    }
  else if (i >= 100)
    {
      *(s + 3) = i % 10 + '0';
      i /= 10;
      *(s + 2) = i % 10 + '0';
      i /= 10;
      *(s + 1) = i % 10 + '0';
      return 4;
    }
  else if (i >= 10)
    {
      *(s + 2) = i % 10 + '0';
      i /= 10;
      *(s + 1) = i % 10 + '0';
      return 3;
    }

  else
    {
      *(s + 1) = i % 10 + '0';
      return 2;
    }
  return 0;
}

void
floatprint (unsigned char *s, float val, unsigned sign, unsigned left,
	    unsigned right, unsigned outlen)
{
/* print float in string */
  unsigned i, len, zero = 1;
  unsigned long uval;
  unsigned char *s0 = s;

  len = left + right;
  if (sign)
    ++len;
  if (right)
    ++len;
  if (len > outlen)
    {
      for (i = 0; i < len; i++)
	s[i] = 'Y';
      return;
    }
  for (i = 0; i < len; i++)
    s[i] = 'X';
/* Take care of sign */
  if (sign)
    {
      if (val < 0)
	{
	  *(s++) = '-';
	  val = -val;
	}
      else
	*(s++) = '+';
    }
  else if (val < 0)
    {
      *s = 'X';
      return;
    }

/* shift right by number of dec. places after dec. point */
  for (i = 0; i < right; i++)
    val *= 10;

/* round to integer value */
  val += 0.5;
  uval = (unsigned long) val;

/* go to last digit in string */
  s += left + right;

  if (right == 0)
    --s;
  else				/* print digits after dec. point */
    {
      for (i = 0; i < right; i++)
	{
	  *(s--) = uval % 10 + '0';
	  uval /= 10;
	}
      *(s--) = '.';		/* print dec. point */
    }

  zero = 0;
  for (i = 0; i < left; i++)	/* print digits before dec. point */
    {
      if (!zero)
	{
	  *(s--) = uval % 10 + '0';
	  uval /= 10;
	  if (uval == 0)
	    zero = 1;
	}
      else
	*(s--) = ' ';
    }
  if (uval != 0)		/*overflow */
    *(++s) = 'X';
  for (i = len; i < outlen; i++)
    s0[i] = ' ';
}

void
ultoa10 (char *s, unsigned long u)
{
  *(s + 9) = u % 10 + '0';
  u /= 10;
  *(s + 8) = u % 10 + '0';
  u /= 10;
  *(s + 7) = u % 10 + '0';
  u /= 10;
  *(s + 6) = u % 10 + '0';
  u /= 10;
  *(s + 5) = u % 10 + '0';
  u /= 10;
  *(s + 4) = u % 10 + '0';
  u /= 10;
  *(s + 3) = u % 10 + '0';
  u /= 10;
  *(s + 2) = u % 10 + '0';
  u /= 10;
  *(s + 1) = u % 10 + '0';
  u /= 10;
  *(s + 0) = u % 10 + '0';
}

int
myatoi (char *s, int len, int *conv)
{
  int sign = +1, pos = 0;
  long n;
  while (pos < len && (s[pos] == ' ' || s[pos] == '\t'))
    ++pos;			/* skip whitespace */
  if (pos == len)
    return (2);
  if (s[pos] == '-')
    {
      sign = -1;
      ++pos;
    }
  else if (s[pos] == '+')
    ++pos;
  if (pos >= len)
    return 2;
  for (n = 0; pos < len && (s[pos] >= '0' && s[pos] <= '9'); ++pos)
    {

      n = 10 * n + (s[pos] - '0');
      if (((sign == +1) && (n > 32767L)) || ((sign == -1) && (-n < -32768L)))
	return 3;
    }
  *conv = n * sign;
  while (pos < len && (s[pos] == ' ' || s[pos] == '\t'))
    ++pos;
  if (pos == len)
    return 0;
  else
    return 1;
}

int
myatof (char *s, int len, float *conv)
{
  int sign = +1, pos = 0, someread = 0, exp = 0, expsign = +1;
  float f, fact;
  while (pos < len && (s[pos] == ' ' || s[pos] == '\t'))
    ++pos;			/* skip whitespace */
  if (pos == len)
    return (2);
  if (s[pos] == '-')
    {
      sign = -1;
      ++pos;
    }
  else if (s[pos] == '+')
    ++pos;
  if (pos >= len)
    return 2;
  for (f = 0.; pos < len && (s[pos] >= '0' && s[pos] <= '9'); ++pos)
    {
      someread = 1;
      f = 10. * f + (s[pos] - '0');
      if (f > 1e12)
	return 3;
    }
  if (s[pos] == '.')
    {
      ++pos;
      for (fact = .1; pos < len && (s[pos] >= '0' && s[pos] <= '9');
	   ++pos, fact /= 10)
	{
	  someread = 1;
	  f += fact * (s[pos] - '0');
	}
    }
  if (!someread)
    return 2;
  if (s[pos] == 'e' || s[pos] == 'E')
    {
      ++pos;
      if (s[pos] == '-')
	{
	  expsign = -1;
	  ++pos;
	}
      else if (s[pos] == '+')
	++pos;
      for (exp = 0; pos < len && (s[pos] >= '0' && s[pos] <= '9'); ++pos)
	{

	  exp = 10 * exp + (s[pos] - '0');
	  if (exp > 12)
	    return 4;
	}
      if (expsign == +1)
	for (; exp > 0; exp--)
	  f *= 10;
      else
	for (; exp > 0; exp--)
	  f /= 10;
    }

  *conv = f * sign;
  while (pos < len && (s[pos] == ' ' || s[pos] == '\t'))
    ++pos;
  if (pos == len)
    return 0;
  else
    return 1;
}

void
uppercase (unsigned char *s, unsigned len)
{
  for (; len > 0; s++, len--)
    if (*s >= 'a' && *s <= 'z')
      *s -= 'a' - 'A';
}

int
namecmp (char const *s1, char const *s2, int len1, int len2)
{
  int i1 = 0, i2 = 0;
  unsigned char c1, c2;
  /* i = position in string; ns= non-space characters */
  while (i1 < len1 && i2 < len2)
    {
      /* skip whitespace */
      if (s1[i1] == ' ' || s1[i1] == '\t')
	{
	  ++i1;
	  continue;
	}
      if (s2[i2] == ' ' || s2[i2] == '\t')
	{
	  ++i2;
	  continue;
	}

      /* convert to uppercase */
      c1 = s1[i1];
      c2 = s2[i2];
      if (c1 >= 'a' && c1 <= 'z')
	c1 -= 'a' - 'A';
      if (c2 >= 'a' && c2 <= 'z')
	c2 -= 'a' - 'A';

      /* compare character */
      if (c1 != c2)
	return 1;		/* different characters */

      /* else s1[i1] == s2[i2] */
      ++i1;
      ++i2;
    }
  /* one string exhausted; test if something other remains */

  for (; i1 < len1; i1++)
    if (s1[i1] != ' ' && s1[i1] != '\t')
      return 2;
  for (; i2 < len2; i2++)
    if (s2[i2] != ' ' && s2[i2] != '\t')
      return 3;
  return 0;
}

int
namecmpbra (char const *s1, char const *s2, int len1, int len2)
{
/* compare until '[' */
  int i1 = 0, i2 = 0;
  unsigned char c1, c2;
  /* i = position in string; ns= non-space characters */
  while (i1 < len1 && i2 < len2 && s1[i1] != '[' && s2[i2] != '[')
    {
      /* skip whitespace */
      if (s1[i1] == ' ' || s1[i1] == '\t')
	{
	  ++i1;
	  continue;
	}
      if (s2[i2] == ' ' || s2[i2] == '\t')
	{
	  ++i2;
	  continue;
	}


      /* convert to uppercase */
      c1 = s1[i1];
      c2 = s2[i2];
      if (c1 >= 'a' && c1 <= 'z')
	c1 -= 'a' - 'A';
      if (c2 >= 'a' && c2 <= 'z')
	c2 -= 'a' - 'A';


      /* compare character */
      if (c1 != c2)
	return 1;		/* different characters */

      /* else s1[i1] == s2[i2] */
      ++i1;
      ++i2;
    }
  /* one string exhausted; test if something non-space remains */

  for (; i1 < len1 && s1[i1] != '['; i1++)
    if (s1[i1] != ' ' && s1[i1] != '\t')
      return 2;
  for (; i2 < len2 && s2[i2] != '['; i2++)
    if (s2[i2] != ' ' && s2[i2] != '\t')
      return 3;
  return 0;
}

void
uctoa8 (char *s, unsigned char c)
{
  int i;
  unsigned char mask = 0x80;
  for (i = 0; i < 8; i++)
    {
      *s++ = (c & mask) ? '1' : '0';
      mask >>= 1;
    }
}
