#include "aamc.h"

#define BCD_BIT0 (P4.DR.BIT.B0)
#define BCD_BIT1 (P4.DR.BIT.B1)

/*
01234567890123456
A+100 +100 +100 X
B+100 +100 +100 Y
78901234567890123
*/

extern int outval[6];
extern int lcdpos;

static inline int
myudiv (long a, int b)
{
  long result;
asm ("divxu.w %1,%0": "=r" (result): "r" (b), "0" (a):"cc");
  return (int) result;
}

static inline long
myumul (int a, int b)
{
  long result;
asm ("mulxu.w %1,%0": "=r" (result): "r" (b), "0" (a):"cc");
  return result;
}


void
lcdout (void)
{
  switch (lcdpos)
    {
      static char c100, c10, c1;
      int i;
      static unsigned int u;
      unsigned long l;

    case 0:
      LCD_out4_command (0x80);	/* cursor home */
      break;
    case 17:
      LCD_out4_command (0xc0);	/* cursor 2nd line */
      break;
    case 1:
      i = outval[0] - 2046;
      if (i < 0)
	{
	  l = myumul (125, -i);
	  LCD_out4_data ('-');
	}
      else
	{
	  l = myumul (125, i);
	  LCD_out4_data ('+');
	}
      u = myudiv (l, 256);
      break;
    case 6:
      i = outval[1] - 2046;
      if (i < 0)
	{
	  l = myumul (125, -i);
	  LCD_out4_data ('-');
	}
      else
	{
	  l = myumul (125, i);
	  LCD_out4_data ('+');
	}
      u = myudiv (l, 256);
      break;
    case 11:
      i = outval[2] - 2046;
      if (i < 0)
	{
	  l = myumul (125, -i);
	  LCD_out4_data ('-');
	}
      else
	{
	  l = myumul (125, i);
	  LCD_out4_data ('+');
	}
      u = myudiv (l, 256);
      break;
    case 18:
      i = outval[3] - 2046;
      if (i < 0)
	{
	  l = myumul (125, -i);
	  LCD_out4_data ('-');
	}
      else
	{
	  l = myumul (125, i);
	  LCD_out4_data ('+');
	}
      u = myudiv (l, 256);
      break;
    case 23:
      i = outval[4] - 2046;
      if (i < 0)
	{
	  l = myumul (125, -i);
	  LCD_out4_data ('-');
	}
      else
	{
	  l = myumul (125, i);
	  LCD_out4_data ('+');
	}
      u = myudiv (l, 256);
      break;
    case 28:
      i = outval[5] - 2046;
      if (i < 0)
	{
	  l = myumul (125, -i);
	  LCD_out4_data ('-');
	}
      else
	{
	  l = myumul (125, i);
	  LCD_out4_data ('+');
	}
      u = myudiv (l, 256);
      break;
    case 2:
    case 7:
    case 12:
    case 19:
    case 24:
    case 29:
      c1 = u % 10 + '0';
      u /= 10;
      c10 = u % 10 + '0';
      u /= 10;
      c100 = u % 10 + '0';
      LCD_out4_data (c100);
      break;
    case 3:
    case 8:
    case 13:
    case 20:
    case 25:
    case 30:
      LCD_out4_data (c10);
      break;
    case 4:
    case 9:
    case 14:
    case 21:
    case 26:
    case 31:
      LCD_out4_data (c1);
      break;
    case 5:
    case 10:
    case 15:
    case 22:
    case 27:
    case 32:
      LCD_out4_data (' ');
      break;
    case 16:
      if (BCD_BIT0)
	LCD_out4_data ('X');
      else
	LCD_out4_data (' ');
      break;
    case 33:
      if (BCD_BIT1)
	LCD_out4_data ('Y');
      else
	LCD_out4_data (' ');
      break;
    }
  ++lcdpos;
  if (lcdpos >= 34)
    lcdpos = 0;
}
