/* lcd.c ghh 16.May 2000 */
/* lcd - support */

#include "aamc.h"

static unsigned char lcdram[2][16];

void
LCD_dsp (unsigned const char *str, int line)
{
  int i;

  if (line == 0)
    LCD_out4_command (0x80);	/* cursor home */
  else
    LCD_out4_command (0xc0);	/* cursor 2nd line */
  waitloop (45);
  for (i = 0; i < 16; i++)
    {				/* output string */
      LCD_out4_data (str[i]);
      waitloop (45);
    }
  memcpy (&(lcdram[line][0]), str, 16);
}

void
LCD_upd (unsigned const char *str, int line)
{
  int i, first, last;

  for (first = 0; first < 16 && str[first] == lcdram[line][first]; ++first);
  if (first > 15)
    return;
  for (last = 15; last >= 0 && str[last] == lcdram[line][last]; --last);
  if (last < 0)
    return;

  if (line == 0)
    LCD_out4_command (0x80 + (unsigned char) first);	/* cursor home */
  else
    LCD_out4_command (0xc0 + (unsigned char) first);	/* cursor 2nd line */
  waitloop (45);
  for (i = first; i <= last; i++)
    {				/* output string */
      LCD_out4_data (str[i]);
      waitloop (45);
    }
  memcpy (lcdram[line], str, 16);
}


void
lcdinit (void)
{
  int i;
  P3.DDR = 0xff;		/* output */

/* LCD initialize */
  waitloop (15000);		/* wait 15ms */
  LCD_out8 (0x03);		/* function set 1 */
  waitloop (4100);		/* wait 4.1 ms */
  LCD_out8 (0x03);		/* function set 2 */
  waitloop (100);		/* wait 100 us */
  LCD_out8 (0x03);		/* function set 3 */
  waitloop (40);
  LCD_out8 (0x02);		/* function set 4-bit interface */
  waitloop (40);

  /* now 4-bit interface is set */
  LCD_out4_command (0x28);	/* function set  4-bit, 2 lines, 5x8 font */
  waitloop (40);
  LCD_out4_command (0x0c);	/* display on, cursor off, blink off */
  waitloop (40);
  LCD_out4_command (0x06);	/* entry mode increment, no shift */
  waitloop (40);
  LCD_out4_command (0x01);	/* clear display */
  waitloop (1640);
  for (i = 0; i < 15; i++)
    lcdram[0][i] = lcdram[1][i] = ' ';
}
