/* lcd1.c ghh 17. June 2000 */
/* lcd - support - non-inline functions */

#include "aamc.h"

/* OUT:P3 -> LCD */
/* 7   6   5   4   3   2   1   0  */
/* x   x   E  RS  DB7 DB6 DB5 DB4 */

/* i/o */
#define	LCD		P3.DR.BYTE

void
LCD_out8 (unsigned char data)
{
  LCD &= ~0x10;			/* R/S=0 */
  data &= 0x0f;			/* clear 4 high bits */
  data |= 0x20;			/* set enable bit */
  LCD = data;			/* output */
  LCD &= ~0x20;			/* clear enable bit */
}

void
LCD_out4_command (unsigned char data)
{
  unsigned char tmp;

  LCD &= ~0x10;			/* R/S=0 */
  tmp = (data >> 4) & 0x0f;	/* 4 high data bits */
  tmp |= 0x20;			/* set enable bit */
  LCD = tmp;			/* output */
  LCD &= ~0x20;			/* clear enable bit */

  tmp = data & 0x0f;		/* 4 low data bits */
  tmp |= 0x20;			/* set enable bit */
  LCD = tmp;			/* output */
  LCD &= ~0x20;			/* clear enable bit */
}

void
LCD_out4_data (unsigned char data)
{
  unsigned char tmp;

  LCD |= 0x10;			/* R/S=1 */
  tmp = (data >> 4) & 0x0f;	/* 4 high data bits */
  tmp |= 0x30;			/* set enable bit, R/S bit */
  LCD = tmp;			/* output */
  LCD &= ~0x20;			/* clear enable bit */

  tmp = data & 0x0f;		/* 4 low data bits */
  tmp |= 0x30;			/* set enable bit, R/S bit */
  LCD = tmp;			/* output */
  LCD &= ~0x20;			/* clear enable bit */
}

