        .h8300h
	.file	"store_restore.S"
	
	.section .text
	.align 1
	
	.global _disablestore
_disablestore:
; 
; int disablestore(void)
; 
; sets the I bit of CCR (Interrupts are disabled),
; returns the value of the bit (Yes/No) BEFORE setting
;
	stc.b ccr,r0l  ; copy condition code register ccr to register R0L
	and.b #128,r0l ; clear all bits except highest (Interrupt enable)
	sub.b r0h,r0h  ; clear upper half of register; R0 is return value
	orc.b #128,ccr ; set highest bit (interrupts disabled)
	rts
	.align 1

	.global _restoreenable
_restoreenable:
;
; void restoreenable (int val);
; 
; if value==false, clears the I bit of CCR (interrupts are enabled)
; if val==true, does nothing

	mov.w	r0,r0	; R0 is function argument
	bne	.L4	; jump if R0 != 0 (true)	
        andc.b #127,ccr ; if false clear highest bit in CCR register
.L4:
	rts
	.end
